package com.jayway.maven.plugins.android.standalonemojos;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on android-maven-plugin.<br/> Call <pre>  mvn android:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Tue Feb 07 16:01:47 GMT 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.8)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "com.madgag:android-maven-plugin:3.1.1.99.0.5-UNOFFICIAL-ROBERTO-RELEASE", 0 );
        append( sb, "", 0 );

        append( sb, "Android Maven Plugin - android-maven-plugin", 0 );
        append( sb, "Maven Plugin for Android Development (unofficial patched build by Roberto Tyley)", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 24 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "apk".equals( goal ) )
        {
            append( sb, "android:apk", 0 );
            append( sb, "Creates the apk file. By default signs it with debug keystore.\nChange that by setting configuration parameter <sign><debug>false</debug></sign>.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "Classifier to add to the artifact generated. If given, the artifact will be an attachment instead.\n", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "extractDuplicates (Default: false)", 2 );
                append( sb, "Allows to detect and extract the duplicate files from embedded jars. In that case, the plugin analyzes the content of all embedded dependencies and checks they are no duplicates inside those dependencies. Indeed, Android does not support duplicates, and all dependencies are inlined in the APK. If duplicates files are found, the resource is kept in the first dependency and removes from others.\n", 3 );
                append( sb, "Expression: ${android.extractDuplicates}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDependenciesHardwareArchitectureDefault (Default: armeabi)", 2 );
                append( sb, "Default hardware architecture for native library dependencies (with &lt;type>so&lt;/type>).\n\nThis value is used for dependencies without classifier, if nativeLibrariesDependenciesHardwareArchitectureOverride is not set.\n\nValid values currently include armeabi and armeabi-v7a.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDependenciesHardwareArchitectureDefault}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDependenciesHardwareArchitectureOverride", 2 );
                append( sb, "Override hardware architecture for native library dependencies (with &lt;type>so&lt;/type>).\n\nThis overrides any classifier on native library dependencies, and any nativeLibrariesDependenciesHardwareArchitectureDefault.\n\nValid values currently include armeabi and armeabi-v7a.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDependenciesHardwareArchitectureOverride}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "renameInstrumentationTargetPackage", 2 );
                append( sb, "Rewrite the manifest so that all of its instrumentation components target the given package. This value will be passed on to the aapt parameter --rename-instrumentation-target-package. Look to aapt for more help on this.\n", 3 );
                append( sb, "Expression: ${android.renameInstrumentationTargetPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "renameManifestPackage", 2 );
                append( sb, "A possibly new package name for the application. This value will be passed on to the aapt parameter --rename-manifest-package. Look to aapt for more help on this.\n", 3 );
                append( sb, "Expression: ${android.renameManifestPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "sign", 2 );
                append( sb, "How to sign the apk.\n\nLooks like this:\n\n<sign>\n\u00a0\u00a0\u00a0\u00a0<debug>auto</debug>\n</sign>\n\nValid values for <debug> are:\n\n-\ttrue = sign with the debug keystore.\n-\tfalse = don\'t sign with the debug keystore.\n-\tboth = create a signed as well as an unsigned apk.\n-\tauto (default) = sign with debug keystore, unless another keystore is defined. (Signing with other keystores is not yet implemented. See Issue 2.)\n\n\n\nCan also be configured from command-line with parameter -Dandroid.sign.debug.\n", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectories", 2 );
                append( sb, "Additional source directories that contain resources to be packaged into the apk.\n\nThese are not source directories, that contain java classes to be compiled. It corresponds to the -df option of the apkbuilder program. It allows you to specify directories, that contain additional resources to be packaged into the apk.\nSo an example inside the plugin configuration could be:\n<configuration>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0...\n\u00a0\u00a0\u00a0<sourceDirectories>\n\u00a0\u00a0\u00a0\u00a0\u00a0<sourceDirectory>${project.basedir}/additionals</sourceDirectory>\n\u00a0\u00a0</sourceDirectories>\n\u00a0\u00a0...\n</configuration>\n", 3 );
                append( sb, "Expression: ${android.sourceDirectories}", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "apklib".equals( goal ) )
        {
            append( sb, "android:apklib", 0 );
            append( sb, "Creates the apklib file.\napklib files do not generate deployable artifacts.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "clean".equals( goal ) )
        {
            append( sb, "android:clean", 0 );
            append( sb, "(no description available)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "ndkBuildLibsOutputDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${android.nativeBuildLibsOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "ndkBuildObjOutputDirectory (Default: ${project.basedir}/obj)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${android.nativeBuildObjOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "skipBuildLibsOutputDirectory (Default: true)", 2 );
                append( sb, "Specifies whether the deletion of the libs/ folder structure should be skipped. This is by default set to skip (true) to avoid unwanted deletions of libraries already present in this structure.", 3 );
                append( sb, "Expression: ${android.nativeBuildSkipCleanLibsOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "skipBuildObjsOutputDirectory (Default: false)", 2 );
                append( sb, "Specifies whether the obj/ build folder structure should be deleted.", 3 );
                append( sb, "Expression: ${android.nativeBuildSkipCleanLibsOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "skipClean (Default: false)", 2 );
                append( sb, "Forces the clean process to be skipped.", 3 );
                append( sb, "Expression: ${android.nativeBuildSkipClean}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deploy".equals( goal ) )
        {
            append( sb, "android:deploy", 0 );
            append( sb, "Deploys the built apk file, or another specified apk, to a connected device.\nAutomatically performed when running mvn integration-test (or mvn install) on a project with instrumentation tests.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "Optionally used to specify a different apk file to deploy to a connected emulator or usb device, instead of the built apk from this project.", 3 );
                append( sb, "Expression: ${android.file}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deploy-dependencies".equals( goal ) )
        {
            append( sb, "android:deploy-dependencies", 0 );
            append( sb, "Deploys all directly declared dependencies of <type>apk</type> in this project\'s pom.\nUsually used in a project with instrumentation tests, to deploy the apk to test onto the device before running the deploying and running the instrumentation tests apk.\nAutomatically performed when running mvn integration-test (or mvn install) on a project with instrumentation tests.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "dex".equals( goal ) )
        {
            append( sb, "android:dex", 0 );
            append( sb, "Converts compiled Java classes to the Android dex format.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "dex", 2 );
                append( sb, "Configuration for the dex command execution. It can be configured in the plugin configuration like so\n<dex>\n\u00a0\u00a0<jvmArguments>\n\u00a0\u00a0\u00a0\u00a0<jvmArgument>-Xms256m</jvmArgument>\n\u00a0\u00a0\u00a0\u00a0<jvmArgument>-Xmx512m</jvmArgument>\n\u00a0\u00a0</jvmArguments>\n\u00a0\u00a0<coreLibrary>true|false</coreLibrary>\n\u00a0\u00a0<noLocals>true|false</noLocals>\n\u00a0\u00a0<optimize>true|false</optimize>\n</dex>\nor via properties dex.* or command line parameters android.dex.*", 3 );
                append( sb, "", 0 );

                append( sb, "dexCoreLibrary (Default: false)", 2 );
                append( sb, "Decides whether to pass the --core-library flag to dx.", 3 );
                append( sb, "Expression: ${android.dex.coreLibrary}", 3 );
                append( sb, "", 0 );

                append( sb, "dexJvmArguments (Default: -Xmx1024M)", 2 );
                append( sb, "Extra JVM Arguments. Using these you can e.g. increase memory for the jvm running the build.", 3 );
                append( sb, "Expression: ${android.dex.jvmArguments}", 3 );
                append( sb, "", 0 );

                append( sb, "dexNoLocals (Default: false)", 2 );
                append( sb, "Decides whether to pass the --no-locals flag to dx.", 3 );
                append( sb, "Expression: ${android.dex.noLocals}", 3 );
                append( sb, "", 0 );

                append( sb, "dexOptimize (Default: true)", 2 );
                append( sb, "Decides whether to pass the --no-optimize flag to dx.", 3 );
                append( sb, "Expression: ${android.dex.optimize}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "emulator-start".equals( goal ) )
        {
            append( sb, "android:emulator-start", 0 );
            append( sb, "EmulatorStartMojo can start the Android Emulator with a specified Android Virtual Device (avd).", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "emulator", 2 );
                append( sb, "Configuration for the emulator goals. Either use the plugin configuration like this\n<emulator>\n\u00a0\u00a0<avd>Default</avd>\n\u00a0\u00a0<wait>20000</wait>\n\u00a0\u00a0<options>-no-skin</options>\n</emulator>\nor configure as properties on the command line as android.emulator.avd, android.emulator.wait and android.emulator.options or in pom or settings file as emulator.avd, emulator.wait and emulator.options.", 3 );
                append( sb, "", 0 );

                append( sb, "emulatorAvd", 2 );
                append( sb, "Name of the Android Virtual Device (emulatorAvd) that will be started by the emulator. Default value is \'Default\'", 3 );
                append( sb, "Expression: ${android.emulator.avd}", 3 );
                append( sb, "", 0 );

                append( sb, "emulatorOptions", 2 );
                append( sb, "Additional command line options for the emulator start up. This option can be used to pass any additional options desired to the invocation of the emulator. Use emulator -help for more details. An example would be \'-no-skin\'.", 3 );
                append( sb, "Expression: ${android.emulator.options}", 3 );
                append( sb, "", 0 );

                append( sb, "emulatorWait", 2 );
                append( sb, "Wait time for the emulator start up.", 3 );
                append( sb, "Expression: ${android.emulator.wait}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "emulator-stop".equals( goal ) )
        {
            append( sb, "android:emulator-stop", 0 );
            append( sb, "EmulatorStartMojo can stop the Android Emulator with a specified Android Virtual Device (avd).", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "emulator", 2 );
                append( sb, "Configuration for the emulator goals. Either use the plugin configuration like this\n<emulator>\n\u00a0\u00a0<avd>Default</avd>\n\u00a0\u00a0<wait>20000</wait>\n\u00a0\u00a0<options>-no-skin</options>\n</emulator>\nor configure as properties on the command line as android.emulator.avd, android.emulator.wait and android.emulator.options or in pom or settings file as emulator.avd, emulator.wait and emulator.options.", 3 );
                append( sb, "", 0 );

                append( sb, "emulatorAvd", 2 );
                append( sb, "Name of the Android Virtual Device (emulatorAvd) that will be started by the emulator. Default value is \'Default\'", 3 );
                append( sb, "Expression: ${android.emulator.avd}", 3 );
                append( sb, "", 0 );

                append( sb, "emulatorOptions", 2 );
                append( sb, "Additional command line options for the emulator start up. This option can be used to pass any additional options desired to the invocation of the emulator. Use emulator -help for more details. An example would be \'-no-skin\'.", 3 );
                append( sb, "Expression: ${android.emulator.options}", 3 );
                append( sb, "", 0 );

                append( sb, "emulatorWait", 2 );
                append( sb, "Wait time for the emulator start up.", 3 );
                append( sb, "Expression: ${android.emulator.wait}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "emulator-stop-all".equals( goal ) )
        {
            append( sb, "android:emulator-stop-all", 0 );
            append( sb, "EmulatorStopeAllMojo will stop all attached devices.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "emulator", 2 );
                append( sb, "Configuration for the emulator goals. Either use the plugin configuration like this\n<emulator>\n\u00a0\u00a0<avd>Default</avd>\n\u00a0\u00a0<wait>20000</wait>\n\u00a0\u00a0<options>-no-skin</options>\n</emulator>\nor configure as properties on the command line as android.emulator.avd, android.emulator.wait and android.emulator.options or in pom or settings file as emulator.avd, emulator.wait and emulator.options.", 3 );
                append( sb, "", 0 );

                append( sb, "emulatorAvd", 2 );
                append( sb, "Name of the Android Virtual Device (emulatorAvd) that will be started by the emulator. Default value is \'Default\'", 3 );
                append( sb, "Expression: ${android.emulator.avd}", 3 );
                append( sb, "", 0 );

                append( sb, "emulatorOptions", 2 );
                append( sb, "Additional command line options for the emulator start up. This option can be used to pass any additional options desired to the invocation of the emulator. Use emulator -help for more details. An example would be \'-no-skin\'.", 3 );
                append( sb, "Expression: ${android.emulator.options}", 3 );
                append( sb, "", 0 );

                append( sb, "emulatorWait", 2 );
                append( sb, "Wait time for the emulator start up.", 3 );
                append( sb, "Expression: ${android.emulator.wait}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generate-sources".equals( goal ) )
        {
            append( sb, "android:generate-sources", 0 );
            append( sb, "Generates R.java based on resources specified by the resources configuration parameter.\nGenerates java files based on aidl files.\n\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "genDirectory (Default: ${project.build.directory}/generated-sources/r)", 2 );
                append( sb, "Override default generated folder containing R.java", 3 );
                append( sb, "Expression: ${android.genDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "genDirectoryAidl (Default: ${project.build.directory}/generated-sources/aidl)", 2 );
                append( sb, "Override default generated folder containing aidl classes", 3 );
                append( sb, "Expression: ${android.genDirectoryAidl}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "android:help", 0 );
            append( sb, "Display help information on android-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0android:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "instrument".equals( goal ) )
        {
            append( sb, "android:instrument", 0 );
            append( sb, "Runs the instrumentation apk on device.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "test", 2 );
                append( sb, "The configuration to use for running instrumentation tests. Complete configuration is possible in the plugin configuration:\n<test>\n\u00a0\u00a0<skip>true|false|auto</skip>\n\u00a0\u00a0<instrumentationPackage>packageName</instrumentationPackage>\n\u00a0\u00a0<instrumentationRunner>className</instrumentationRunner>\n\u00a0\u00a0<debug>true|false</debug>\n\u00a0\u00a0<coverage>true|false</coverage>\n\u00a0\u00a0<logOnly>true|false</logOnly>\u00a0\u00a0avd\n\u00a0\u00a0<testSize>small|medium|large</testSize>\n\u00a0\u00a0<createReport>true|false</createReport>\n\u00a0\u00a0<classes>\n\u00a0\u00a0\u00a0\u00a0<class>your.package.name.YourTestClass</class>\n\u00a0\u00a0</classes>\n\u00a0\u00a0<packages>\n\u00a0\u00a0\u00a0\u00a0<package>your.package.name</package>\n\u00a0\u00a0</packages>\n</test>\n", 3 );
                append( sb, "", 0 );

                append( sb, "testClasses", 2 );
                append( sb, "Whether to execute test classes which are specified as part of the instrumentation tests.\n\n<classes>\n\u00a0\u00a0\u00a0\u00a0<class>your.package.name.YourTestClass</class>\n</classes>\nor as e.g. -Dandroid.test.classes=class1,class2", 3 );
                append( sb, "Expression: ${android.test.classes}", 3 );
                append( sb, "", 0 );

                append( sb, "testCoverage (Default: false)", 2 );
                append( sb, "Enable or disable code coverage for this instrumentation test run.", 3 );
                append( sb, "Expression: ${android.test.coverage}", 3 );
                append( sb, "", 0 );

                append( sb, "testCreateReport (Default: true)", 2 );
                append( sb, "Create a junit xml format compatible output file containing the test results for each device the instrumentation tests run on.\n\nThe files are stored in target/surefire-reports and named TEST-deviceid.xml. The deviceid for an emulator is deviceSerialNumber_avdName_manufacturer_model. The serial number is commonly emulator-5554 for the first emulator started with numbers increasing. avdName is as defined in the SDK tool. The manufacturer is typically \'unknown\' and the model is typically \'sdk\'. The deviceid for an actual devices is deviceSerialNumber_manufacturer_model.\n\nThe file contains system properties from the system running the Android Maven Plugin (JVM) and device properties from the device/emulator the tests are running on.\n\nThe file contains a single TestSuite for all tests and a TestCase for each test method. Errors and failures are logged in the file and the system log with full stack traces and other details available.", 3 );
                append( sb, "Expression: ${android.test.createreport}", 3 );
                append( sb, "", 0 );

                append( sb, "testDebug (Default: false)", 2 );
                append( sb, "Enable debug causing the test runner to wait until debugger is connected with the Android debug bridge (adb).", 3 );
                append( sb, "Expression: ${android.test.debug}", 3 );
                append( sb, "", 0 );

                append( sb, "testInstrumentationPackage", 2 );
                append( sb, "Package name of the apk we wish to instrument. If not specified, it is inferred from AndroidManifest.xml.", 3 );
                append( sb, "Expression: ${android.test.instrumentationPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "testInstrumentationRunner", 2 );
                append( sb, "Class name of test runner. If not specified, it is inferred from AndroidManifest.xml.", 3 );
                append( sb, "Expression: ${android.test.instrumentationRunner}", 3 );
                append( sb, "", 0 );

                append( sb, "testLogOnly (Default: false)", 2 );
                append( sb, "Enable this flag to run a log only and not execute the tests.", 3 );
                append( sb, "Expression: ${android.test.logonly}", 3 );
                append( sb, "", 0 );

                append( sb, "testPackages", 2 );
                append( sb, "Whether to execute tests only in given packages as part of the instrumentation tests.\n\n<packages>\n\u00a0\u00a0\u00a0\u00a0<package>your.package.name</package>\n</packages>\nor as e.g. -Dandroid.test.packages=package1,package2", 3 );
                append( sb, "Expression: ${android.test.packages}", 3 );
                append( sb, "", 0 );

                append( sb, "testSkip (Default: auto)", 2 );
                append( sb, "Enables or disables integration test related goals. If true they will be skipped; if false, they will be run. If auto, they will run if any of the classes inherit from any class in junit.framework.** or android.test.**.", 3 );
                append( sb, "Expression: ${android.test.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "testTestSize", 2 );
                append( sb, "If specified only execute tests of certain size as defined by the Android instrumentation testing SmallTest, MediumTest and LargeTest annotations. Use \'small\', \'medium\' or \'large\' as values.", 3 );
                append( sb, "Expression: ${android.test.testsize}", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "internal-integration-test".equals( goal ) )
        {
            append( sb, "android:internal-integration-test", 0 );
            append( sb, "Internal. Do not use.\nCalled automatically when the lifecycle reaches phase integration-test. Figures out whether to call goals in this phase; and if so, calls android:instrument.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "test", 2 );
                append( sb, "The configuration to use for running instrumentation tests. Complete configuration is possible in the plugin configuration:\n<test>\n\u00a0\u00a0<skip>true|false|auto</skip>\n\u00a0\u00a0<instrumentationPackage>packageName</instrumentationPackage>\n\u00a0\u00a0<instrumentationRunner>className</instrumentationRunner>\n\u00a0\u00a0<debug>true|false</debug>\n\u00a0\u00a0<coverage>true|false</coverage>\n\u00a0\u00a0<logOnly>true|false</logOnly>\u00a0\u00a0avd\n\u00a0\u00a0<testSize>small|medium|large</testSize>\n\u00a0\u00a0<createReport>true|false</createReport>\n\u00a0\u00a0<classes>\n\u00a0\u00a0\u00a0\u00a0<class>your.package.name.YourTestClass</class>\n\u00a0\u00a0</classes>\n\u00a0\u00a0<packages>\n\u00a0\u00a0\u00a0\u00a0<package>your.package.name</package>\n\u00a0\u00a0</packages>\n</test>\n", 3 );
                append( sb, "", 0 );

                append( sb, "testClasses", 2 );
                append( sb, "Whether to execute test classes which are specified as part of the instrumentation tests.\n\n<classes>\n\u00a0\u00a0\u00a0\u00a0<class>your.package.name.YourTestClass</class>\n</classes>\nor as e.g. -Dandroid.test.classes=class1,class2", 3 );
                append( sb, "Expression: ${android.test.classes}", 3 );
                append( sb, "", 0 );

                append( sb, "testCoverage (Default: false)", 2 );
                append( sb, "Enable or disable code coverage for this instrumentation test run.", 3 );
                append( sb, "Expression: ${android.test.coverage}", 3 );
                append( sb, "", 0 );

                append( sb, "testCreateReport (Default: true)", 2 );
                append( sb, "Create a junit xml format compatible output file containing the test results for each device the instrumentation tests run on.\n\nThe files are stored in target/surefire-reports and named TEST-deviceid.xml. The deviceid for an emulator is deviceSerialNumber_avdName_manufacturer_model. The serial number is commonly emulator-5554 for the first emulator started with numbers increasing. avdName is as defined in the SDK tool. The manufacturer is typically \'unknown\' and the model is typically \'sdk\'. The deviceid for an actual devices is deviceSerialNumber_manufacturer_model.\n\nThe file contains system properties from the system running the Android Maven Plugin (JVM) and device properties from the device/emulator the tests are running on.\n\nThe file contains a single TestSuite for all tests and a TestCase for each test method. Errors and failures are logged in the file and the system log with full stack traces and other details available.", 3 );
                append( sb, "Expression: ${android.test.createreport}", 3 );
                append( sb, "", 0 );

                append( sb, "testDebug (Default: false)", 2 );
                append( sb, "Enable debug causing the test runner to wait until debugger is connected with the Android debug bridge (adb).", 3 );
                append( sb, "Expression: ${android.test.debug}", 3 );
                append( sb, "", 0 );

                append( sb, "testInstrumentationPackage", 2 );
                append( sb, "Package name of the apk we wish to instrument. If not specified, it is inferred from AndroidManifest.xml.", 3 );
                append( sb, "Expression: ${android.test.instrumentationPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "testInstrumentationRunner", 2 );
                append( sb, "Class name of test runner. If not specified, it is inferred from AndroidManifest.xml.", 3 );
                append( sb, "Expression: ${android.test.instrumentationRunner}", 3 );
                append( sb, "", 0 );

                append( sb, "testLogOnly (Default: false)", 2 );
                append( sb, "Enable this flag to run a log only and not execute the tests.", 3 );
                append( sb, "Expression: ${android.test.logonly}", 3 );
                append( sb, "", 0 );

                append( sb, "testPackages", 2 );
                append( sb, "Whether to execute tests only in given packages as part of the instrumentation tests.\n\n<packages>\n\u00a0\u00a0\u00a0\u00a0<package>your.package.name</package>\n</packages>\nor as e.g. -Dandroid.test.packages=package1,package2", 3 );
                append( sb, "Expression: ${android.test.packages}", 3 );
                append( sb, "", 0 );

                append( sb, "testSkip (Default: auto)", 2 );
                append( sb, "Enables or disables integration test related goals. If true they will be skipped; if false, they will be run. If auto, they will run if any of the classes inherit from any class in junit.framework.** or android.test.**.", 3 );
                append( sb, "Expression: ${android.test.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "testTestSize", 2 );
                append( sb, "If specified only execute tests of certain size as defined by the Android instrumentation testing SmallTest, MediumTest and LargeTest annotations. Use \'small\', \'medium\' or \'large\' as values.", 3 );
                append( sb, "Expression: ${android.test.testsize}", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "internal-pre-integration-test".equals( goal ) )
        {
            append( sb, "android:internal-pre-integration-test", 0 );
            append( sb, "Internal. Do not use.\nCalled automatically when the lifecycle reaches phase pre-integration-test. Figures out whether to call goals in this phase; and if so, calls android:deploy-dependencies and android:deploy.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "test", 2 );
                append( sb, "The configuration to use for running instrumentation tests. Complete configuration is possible in the plugin configuration:\n<test>\n\u00a0\u00a0<skip>true|false|auto</skip>\n\u00a0\u00a0<instrumentationPackage>packageName</instrumentationPackage>\n\u00a0\u00a0<instrumentationRunner>className</instrumentationRunner>\n\u00a0\u00a0<debug>true|false</debug>\n\u00a0\u00a0<coverage>true|false</coverage>\n\u00a0\u00a0<logOnly>true|false</logOnly>\u00a0\u00a0avd\n\u00a0\u00a0<testSize>small|medium|large</testSize>\n\u00a0\u00a0<createReport>true|false</createReport>\n\u00a0\u00a0<classes>\n\u00a0\u00a0\u00a0\u00a0<class>your.package.name.YourTestClass</class>\n\u00a0\u00a0</classes>\n\u00a0\u00a0<packages>\n\u00a0\u00a0\u00a0\u00a0<package>your.package.name</package>\n\u00a0\u00a0</packages>\n</test>\n", 3 );
                append( sb, "", 0 );

                append( sb, "testClasses", 2 );
                append( sb, "Whether to execute test classes which are specified as part of the instrumentation tests.\n\n<classes>\n\u00a0\u00a0\u00a0\u00a0<class>your.package.name.YourTestClass</class>\n</classes>\nor as e.g. -Dandroid.test.classes=class1,class2", 3 );
                append( sb, "Expression: ${android.test.classes}", 3 );
                append( sb, "", 0 );

                append( sb, "testCoverage (Default: false)", 2 );
                append( sb, "Enable or disable code coverage for this instrumentation test run.", 3 );
                append( sb, "Expression: ${android.test.coverage}", 3 );
                append( sb, "", 0 );

                append( sb, "testCreateReport (Default: true)", 2 );
                append( sb, "Create a junit xml format compatible output file containing the test results for each device the instrumentation tests run on.\n\nThe files are stored in target/surefire-reports and named TEST-deviceid.xml. The deviceid for an emulator is deviceSerialNumber_avdName_manufacturer_model. The serial number is commonly emulator-5554 for the first emulator started with numbers increasing. avdName is as defined in the SDK tool. The manufacturer is typically \'unknown\' and the model is typically \'sdk\'. The deviceid for an actual devices is deviceSerialNumber_manufacturer_model.\n\nThe file contains system properties from the system running the Android Maven Plugin (JVM) and device properties from the device/emulator the tests are running on.\n\nThe file contains a single TestSuite for all tests and a TestCase for each test method. Errors and failures are logged in the file and the system log with full stack traces and other details available.", 3 );
                append( sb, "Expression: ${android.test.createreport}", 3 );
                append( sb, "", 0 );

                append( sb, "testDebug (Default: false)", 2 );
                append( sb, "Enable debug causing the test runner to wait until debugger is connected with the Android debug bridge (adb).", 3 );
                append( sb, "Expression: ${android.test.debug}", 3 );
                append( sb, "", 0 );

                append( sb, "testInstrumentationPackage", 2 );
                append( sb, "Package name of the apk we wish to instrument. If not specified, it is inferred from AndroidManifest.xml.", 3 );
                append( sb, "Expression: ${android.test.instrumentationPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "testInstrumentationRunner", 2 );
                append( sb, "Class name of test runner. If not specified, it is inferred from AndroidManifest.xml.", 3 );
                append( sb, "Expression: ${android.test.instrumentationRunner}", 3 );
                append( sb, "", 0 );

                append( sb, "testLogOnly (Default: false)", 2 );
                append( sb, "Enable this flag to run a log only and not execute the tests.", 3 );
                append( sb, "Expression: ${android.test.logonly}", 3 );
                append( sb, "", 0 );

                append( sb, "testPackages", 2 );
                append( sb, "Whether to execute tests only in given packages as part of the instrumentation tests.\n\n<packages>\n\u00a0\u00a0\u00a0\u00a0<package>your.package.name</package>\n</packages>\nor as e.g. -Dandroid.test.packages=package1,package2", 3 );
                append( sb, "Expression: ${android.test.packages}", 3 );
                append( sb, "", 0 );

                append( sb, "testSkip (Default: auto)", 2 );
                append( sb, "Enables or disables integration test related goals. If true they will be skipped; if false, they will be run. If auto, they will run if any of the classes inherit from any class in junit.framework.** or android.test.**.", 3 );
                append( sb, "Expression: ${android.test.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "testTestSize", 2 );
                append( sb, "If specified only execute tests of certain size as defined by the Android instrumentation testing SmallTest, MediumTest and LargeTest annotations. Use \'small\', \'medium\' or \'large\' as values.", 3 );
                append( sb, "Expression: ${android.test.testsize}", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "manifest-update".equals( goal ) )
        {
            append( sb, "android:manifest-update", 0 );
            append( sb, "Updates various version attributes present in the AndroidManifest.xml file.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "manifest", 2 );
                append( sb, "Configuration for the manifest-update goal.\nYou can configure this mojo to update the following manifest attributes:\n\nandroid:versionName on the manifest element. android:versionCode on the manifest element. android:sharedUserId on the manifest element. android:debuggable on the application element.\n\nNote: This process will reformat the AndroidManifest.xml per JAXP Transformer defaults if updates are made to the manifest.\n\nYou can configure attributes in the plugin configuration like so\n\n\u00a0\u00a0<plugin>\n\u00a0\u00a0\u00a0\u00a0<groupId>com.madgag</groupId>\n\u00a0\u00a0\u00a0\u00a0<artifactId>android-maven-plugin</artifactId>\n\u00a0\u00a0\u00a0\u00a0<executions>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<execution>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<id>update-manifest</id>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<goals>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<goal>manifest-update</goal>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0</goals>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<configuration>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<manifest>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<versionName></versionName>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<versionCode>123</versionCode>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<versionCodeAutoIncrement>true|false</versionCodeAutoIncrement>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<versionCodeUpdateFromVersion>true|false</versionCodeUpdateFromVersion>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<sharedUserId>anId</sharedUserId>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<debuggable>true|false</debuggable>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0</manifest>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0</configuration>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0</execution>\n\u00a0\u00a0\u00a0\u00a0</executions>\n\u00a0\u00a0</plugin>\nor use properties set in the pom or settings file or supplied as command line parameter. Add \'android.\' in front of the property name for command line usage. All parameters follow a manifest.* naming convention.", 3 );
                append( sb, "", 0 );

                append( sb, "manifestDebuggable", 2 );
                append( sb, "Update the android:debuggable attribute with the specified parameter.", 3 );
                append( sb, "Expression: ${android.manifest.debuggable}", 3 );
                append( sb, "", 0 );

                append( sb, "manifestSharedUserId", 2 );
                append( sb, "Update the android:sharedUserId attribute with the specified parameter.", 3 );
                append( sb, "Expression: ${android.manifest.sharedUserId}", 3 );
                append( sb, "", 0 );

                append( sb, "manifestVersionCode", 2 );
                append( sb, "Update the android:versionCode attribute with the specified parameter.", 3 );
                append( sb, "Expression: ${android.manifest.versionCode}", 3 );
                append( sb, "", 0 );

                append( sb, "manifestVersionCodeAutoIncrement (Default: false)", 2 );
                append( sb, "Auto increment the android:versionCode attribute with each build.", 3 );
                append( sb, "Expression: ${android.manifest.versionCodeAutoIncrement}", 3 );
                append( sb, "", 0 );

                append( sb, "manifestVersionCodeUpdateFromVersion", 2 );
                append( sb, "Update the android:versionCode attribute automatically from the project version e.g 3.0.1 will become version code 301. As described in this blog post http://www.simpligility.com/2010/11/release-version-management-for-your-android-application/ but done without using resource filtering.", 3 );
                append( sb, "Expression: ${android.manifest.versionCodeUpdateFromVersion} default-value=", 3 );
                append( sb, "", 0 );

                append( sb, "manifestVersionName (Default: ${project.version})", 2 );
                append( sb, "Update the android:versionName with the specified parameter. If left empty it will use the version number of the project.", 3 );
                append( sb, "Expression: ${android.manifest.versionName}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "ndk-build".equals( goal ) )
        {
            append( sb, "android:ndk-build", 0 );
            append( sb, "(no description available)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachHeaderFiles", 2 );
                append( sb, "Flag indicating whether the header files used in the build should be included and attached to the build as an additional artifact.", 3 );
                append( sb, "Expression: ${android.ndk.build.attach-header-files}", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachNativeArtifacts", 2 );
                append( sb, "Flag indicating whether the resulting native library should be attached as an artifact to the build. This means the resulting .so is installed into the repository as well as being included in the final APK.", 3 );
                append( sb, "Expression: ${android.ndk.build.attach-native-artifact}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "buildWarningsRegularExpression", 2 );
                append( sb, "Defines the regular expression used to detect whether error/warning output from ndk-build is a minor compile warning or is actually an error which should cause the build to fail. If the pattern matches, the output from the compiler will not be considered an error and compile will be successful.", 3 );
                append( sb, "Expression: ${android.ndk.build.build-warnings-regular-expression}", 3 );
                append( sb, "", 0 );

                append( sb, "clearNativeArtifacts", 2 );
                append( sb, "Flag indicating whether the NDK output directory (libs/<architecture>) should be cleared after build. This will essentially \'move\' all the native artifacts (.so) to the ${project.build.directory}/libs/<architecture>. If an APK is built as part of the invocation, the libraries will be included from here.", 3 );
                append( sb, "Expression: ${android.ndk.build.clear-native-artifacts}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "headerFilesDirectives", 2 );
                append( sb, "Specifies the set of header files includes/excludes which should be used for bundling the exported header files. The below shows an example of how this can be used.\n<headerFilesDirectives>\n\u00a0\u00a0<headerFilesDirective>\n\u00a0\u00a0\u00a0\u00a0<directory>${basedir}/jni/include</directory>\n\u00a0\u00a0\u00a0\u00a0<includes>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<includes>**\\/*.h</include>\n\u00a0\u00a0\u00a0\u00a0</includes>\n\u00a0\u00a0<headerFilesDirective>\n</headerFilesDirectives>\n\nIf no headerFilesDirectives is specified, the default includes will be defined as shown below:\n\n<headerFilesDirectives>\n\u00a0\u00a0<headerFilesDirective>\n\u00a0\u00a0\u00a0\u00a0<directory>${basedir}/jni</directory>\n\u00a0\u00a0\u00a0\u00a0<includes>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<includes>**\\/*.h</include>\n\u00a0\u00a0\u00a0\u00a0</includes>\n\u00a0\u00a0\u00a0\u00a0<excludes>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<exclude>**\\/*.c</exclude>\n\u00a0\u00a0\u00a0\u00a0</excludes>\n\u00a0\u00a0<headerFilesDirective>\n\u00a0\u00a0[..]\n</headerFilesDirectives>\n", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreBuildWarnings", 2 );
                append( sb, "Flag indicating whether warnings should be ignored while compiling. If true, the build will not fail if warning are found during compile.", 3 );
                append( sb, "Expression: ${android.ndk.build.ignore-build-warnings}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesOutputDirectory (Default: ${project.basedir}/obj/local)", 2 );
                append( sb, "Folder containing native, static libraries compiled and linked by the NDK.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "ndk", 2 );
                append( sb, "The Android NDK to use.\n\nLooks like this:\n\n<ndk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-ndk-r4</path>\n</ndk>\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_NDK_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<ndk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_NDK_HOME}</path>\n</ndk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameter -Dandroid.ndk.path.\n", 3 );
                append( sb, "", 0 );

                append( sb, "ndkArchitecture", 2 );
                append( sb, "Defines the architecture for the NDK build", 3 );
                append( sb, "Expression: ${android.ndk.build.architecture}", 3 );
                append( sb, "", 0 );

                append( sb, "ndkBuildAdditionalCommandline", 2 );
                append( sb, "Specifies additional command line parameters to pass to ndk-build", 3 );
                append( sb, "Expression: ${android.ndk.build.command-line}", 3 );
                append( sb, "", 0 );

                append( sb, "ndkBuildDirectory", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${android.ndk.ndk-build-directory}", 3 );
                append( sb, "", 0 );

                append( sb, "ndkBuildExecutable", 2 );
                append( sb, "Allows for overriding the default ndk-build executable.", 3 );
                append( sb, "Expression: ${android.ndk.ndk-build-executable}", 3 );
                append( sb, "", 0 );

                append( sb, "ndkClassifier", 2 );
                append( sb, "Specifies the classifier with which the artifact should be stored in the repository", 3 );
                append( sb, "Expression: ${android.ndk.build.native-classifier}", 3 );
                append( sb, "", 0 );

                append( sb, "ndkOutputDirectory (Default: ${project.build.directory}/ndk-libs)", 2 );
                append( sb, "Build folder to place built native libraries into", 3 );
                append( sb, "Expression: ${android.ndk.build.ndk-output-directory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "systemProperties", 2 );
                append( sb, "Defines additional system properties which should be exported to the ndk-build script. This\n\n<systemProperties>\n\u00a0\u00a0<propertyName>propertyValue</propertyName>\n\u00a0\u00a0<build-target>android</build-target>\n\u00a0\u00a0[..]\n</systemProperties>\n*", 3 );
                append( sb, "", 0 );

                append( sb, "target", 2 );
                append( sb, "Target to invoke on the native makefile.\n", 3 );
                append( sb, "Expression: ${android.nativeTarget}", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );

                append( sb, "useHeaderArchives", 2 );
                append( sb, "Flag indicating whether the header files for native, static library dependencies should be used. If true, the header archive for each statically linked dependency will be resolved.", 3 );
                append( sb, "Expression: ${android.ndk.build.use-header-archives}", 3 );
                append( sb, "", 0 );

                append( sb, "useLocalSrcIncludePaths", 2 );
                append( sb, "Flag indicating whether the make files last LOCAL_SRC_INCLUDES should be used for determing what header files to include. Setting this flag to true, overrides any defined header files directives. Note: By setting this flag to true, all header files used in the project will be added to the resulting header archive. This may be undesirable in most cases and is therefore turned off by default.", 3 );
                append( sb, "Expression: ${android.ndk.build.use-local-src-include-paths}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "proguard".equals( goal ) )
        {
            append( sb, "android:proguard", 0 );
            append( sb, "Processes both application and dependency classes using the ProGuard byte code obfuscator, minimzer, and optimizer. For more information, see https://proguard.sourceforge.net.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "proguard", 2 );
                append( sb, "Enables ProGuard for this build. ProGuard is disabled by default, so in order for it to run, enable it like so:\n\n<proguard>\n\u00a0\u00a0\u00a0<skip>false</skip>\n\u00a0\u00a0\u00a0<config>proguard.cfg</config>\n\u00a0\u00a0\u00a0<proguardJarPath>someAbsolutePathToProguardJar</proguardJarPath>\n\u00a0\u00a0\u00a0<jvmArguments>\n\u00a0\u00a0\u00a0\u00a0<jvmArgument>-Xms256m</jvmArgument>\n\u00a0\u00a0\u00a0\u00a0<jvmArgument>-Xmx512m</jvmArgument>\n\u00a0\u00a0</jvmArguments>\n</proguard>\n\nA good practice is to create a release profile in your POM, in which you enable ProGuard. ProGuard should be disabled for development builds, since it obfuscates class and field names, and since it may interfere with test projects that rely on your application classes.\n", 3 );
                append( sb, "", 0 );

                append( sb, "proguardConfig (Default: proguard.cfg)", 2 );
                append( sb, "Path to the ProGuard configuration file (relative to project root).", 3 );
                append( sb, "Expression: ${android.proguard.config}", 3 );
                append( sb, "", 0 );

                append( sb, "proguardJvmArguments (Default: -Xmx512M)", 2 );
                append( sb, "Extra JVM Arguments. Using these you can e.g. increase memory for the jvm running the build.", 3 );
                append( sb, "Expression: ${android.proguard.jvmArguments}", 3 );
                append( sb, "", 0 );

                append( sb, "proguardProguardJarPath", 2 );
                append( sb, "Path to the proguard jar to be used. By default this will load the jar from the Android SDK install. Overriding it with an absolute path allows you to use a newer or custom proguard version e.g. located in your local Maven repo.", 3 );
                append( sb, "Expression: ${android.proguard.proguardJarPath}", 3 );
                append( sb, "", 0 );

                append( sb, "proguardSkip (Default: true)", 2 );
                append( sb, "Whether ProGuard is enabled or not.", 3 );
                append( sb, "Expression: ${android.proguard.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "pull".equals( goal ) )
        {
            append( sb, "android:pull", 0 );
            append( sb, "Copy file or directory from all the attached (or specified) devices/emulators.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "pull", 2 );
                append( sb, "The configuration for the pull goal can be set up in the plugin configuration in the pom file as:\n\n<pull>\n\u00a0\u00a0\u00a0\u00a0<source>path</source>\n\u00a0\u00a0\u00a0\u00a0<destination>path</destination>\n</pull>\n\nThe parameters can also be configured as property in the pom or settings file\n\n<properties>\n\u00a0\u00a0\u00a0\u00a0<pull.source>pathondevice</pull.source>\n\u00a0\u00a0\u00a0\u00a0<pull.destination>path</pull.destination>\n</properties>\nor from command-line with parameter -Dandroid.pull.source=path and -Dandroid.pull.destination=path.\n\n", 3 );
                append( sb, "", 0 );

                append( sb, "pullDestination", 2 );
                append( sb, "The path of the destination to copy the file to. If destination ends with File.separator, it is supposed to be a directory. Therefore the source - whether it refers to a file or directory - will be copied into the destination directory. If destination does not end with File.separator, the last path segment will be assumed as the new file or directory name (depending on the type of source). Any missing directories will be created.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${android.pull.destination}", 3 );
                append( sb, "", 0 );

                append( sb, "pullSource", 2 );
                append( sb, "The path of the source file or directory on the emulator/device.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${android.pull.source}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "push".equals( goal ) )
        {
            append( sb, "android:push", 0 );
            append( sb, "Copy file to all the attached (or specified) devices/emulators.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "push", 2 );
                append( sb, "The configuration for the push goal can be set up in the plugin configuration in the pom file as:\n\n<push>\n\u00a0\u00a0\u00a0\u00a0<source>path</source>\n\u00a0\u00a0\u00a0\u00a0<destination>path</destination>\n</push>\n\nThe parameters can also be configured as property in the pom or settings file\n\n<properties>\n\u00a0\u00a0\u00a0\u00a0<push.source>pathondevice</push.source>\n\u00a0\u00a0\u00a0\u00a0<push.destination>path</push.destination>\n</properties>\nor from command-line with parameter -Dandroid.push.source=path and -Dandroid.push.destination=path.\n\n", 3 );
                append( sb, "", 0 );

                append( sb, "pushDestination", 2 );
                append( sb, "The destination file name as absolute path on the emulator or device. If the last character is a \'/\' it will be assumed that the original base filename should be preserved and a target directory is specified. This works analogous if the source is a directory.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${android.push.destination}", 3 );
                append( sb, "", 0 );

                append( sb, "pushSource", 2 );
                append( sb, "The file name of the local filesystem file to push to the emulator or device either as absolute path or relative to the execution folder. If you specify a directory, all containing files will be pushed recursively.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${android.push.source}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "redeploy".equals( goal ) )
        {
            append( sb, "android:redeploy", 0 );
            append( sb, "Redeploys the built apk file, or another specified apk, to a connected device. This simply tries to undeploy the APK and re-deploy it.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "Optionally used to specify a different apk file to deploy to a connected emulator or usb device, instead of the built apk from this project.", 3 );
                append( sb, "Expression: ${android.file}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "run".equals( goal ) )
        {
            append( sb, "android:run", 0 );
            append( sb, "Runs the first Activity shown in the top-level launcher as determined by its Intent filters.\nAndroid provides a component-based architecture, which means that there is no \'main\' function which serves as an entry point to the APK. There\'s an homogeneous collection of Activity(es), Service(s), Receiver(s), etc.\n\nThe Android top-level launcher (whose purpose is to allow users to launch other applications) uses the Intent resolution mechanism to determine which Activity(es) to show to the end user. Such activities are identified by at least:\n\n-\tAction type: android.intent.action.MAIN\n-\tCategory: android.intent.category.LAUNCHER\n\n\n\nAnd are declared in AndroidManifest.xml as such:\n\n<activity\u00a0android:name=\'.ExampleActivity\'>\n\u00a0\u00a0\u00a0\u00a0<intent-filter>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<action\u00a0android:name=\'android.intent.action.MAIN\'\u00a0/>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<category\u00a0android:name=\'android.intent.category.LAUNCHER\'\u00a0/>\n\u00a0\u00a0\u00a0\u00a0</intent-filter>\n</activity>\n\nThis Mojo will try to to launch the first activity of this kind found in AndroidManifest.xml. In case multiple activities satisfy the requirements listed above only the first declared one is run. In case there are no \'Launcher activities\' declared in the manifest or no activities declared at all, this goal aborts throwing an error.\n\nThe device parameter is taken into consideration so potentially the Activity found is started on all attached devices. The application will NOT be deployed and running will silently fail if the application is not deployed.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "run", 2 );
                append( sb, "The configuration for the run goal can be set up in the plugin configuration in the pom file as:\n\n<run>\n\u00a0\u00a0\u00a0\u00a0<debug>true</debug>\n</run>\n\nThe <debug> parameter is optional and defaults to false.\n\nThe debug parameter can also be configured as property in the pom or settings file\n\n<properties>\n\u00a0\u00a0\u00a0\u00a0<run.debug>true</run.debug>\n</properties>\nor from command-line with parameter -Dandroid.run.debug=true.\n\n", 3 );
                append( sb, "", 0 );

                append( sb, "runDebug (Default: false)", 2 );
                append( sb, "Debug parameter for the the run goal. If true, the device or emulator will pause execution of the process at startup to wait for a debugger to connect. Also see the \'run\' parameter documentation.", 3 );
                append( sb, "Expression: ${android.run.debug}", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "undeploy".equals( goal ) )
        {
            append( sb, "android:undeploy", 0 );
            append( sb, "Undeploys the built apk file, or another specified apk, from a connected device.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "Optionally used to specify a different apk file to undeploy from a connected emulator or usb device, instead of the built apk from this project.", 3 );
                append( sb, "Expression: ${android.file}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "package (Default: null)", 2 );
                append( sb, "Optionally used to specify a different apk package to undeploy from a connected emulator or usb device, instead of the built apk from this project.", 3 );
                append( sb, "Expression: ${android.package}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "unpack".equals( goal ) )
        {
            append( sb, "android:unpack", 0 );
            append( sb, "Unpack libraries code and dependencies into target. This can be useful for using the proguard maven plugin to provide the input jars. Although it is encouraged to use the proguard mojo of the android maven plugin.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "lazyLibraryUnpack (Default: false)", 2 );
                append( sb, "If true, the library will be unpacked only when outputDirectory doesn\'t exist, i.e, a clean build for most cases.", 3 );
                append( sb, "Expression: ${android.lazyLibraryUnpack}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "zipalign".equals( goal ) )
        {
            append( sb, "android:zipalign", 0 );
            append( sb, "ZipalignMojo can run the zipalign command against the apk.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aaptExtraArgs", 2 );
                append( sb, "A list of extra arguments that must be passed to aapt.", 3 );
                append( sb, "Expression: ${android.aaptExtraArgs}", 3 );
                append( sb, "", 0 );

                append( sb, "androidManifestFile (Default: ${project.basedir}/AndroidManifest.xml)", 2 );
                append( sb, "The AndroidManifest.xml file.", 3 );
                append( sb, "", 0 );

                append( sb, "assetsDirectory (Default: ${project.basedir}/assets)", 2 );
                append( sb, "The android assets directory.", 3 );
                append( sb, "", 0 );

                append( sb, "attachJar (Default: true)", 2 );
                append( sb, "Whether to attach the normal .jar file to the build, so it can be depended on by for example integration-tests which may then access R.java from this project.\n\nOnly disable it if you know you won\'t need it for any integration-tests. Otherwise, leave it enabled.\n", 3 );
                append( sb, "Expression: ${android.attachJar}", 3 );
                append( sb, "", 0 );

                append( sb, "attachSources (Default: false)", 2 );
                append( sb, "Whether to attach sources to the build, which can be depended on by other apk projects, for including them in their builds.\n\nEnabling this setting is only required if this project\'s source code and/or res(ources) will be included in other projects, using the Maven <dependency> tag.\n", 3 );
                append( sb, "Expression: ${android.attachSources}", 3 );
                append( sb, "", 0 );

                append( sb, "configurations", 2 );
                append( sb, "A selection of configurations to be included in the APK as a comma separated list. This will limit the configurations for a certain type. For example, specifying hdpi will exclude all resource folders with the mdpi or ldpi modifiers, but won\'t affect language or orientation modifiers. For more information about this option, look in the aapt command line help.", 3 );
                append( sb, "Expression: ${android.configurations}", 3 );
                append( sb, "", 0 );

                append( sb, "customPackage", 2 );
                append( sb, "Generates R.java into a different package.", 3 );
                append( sb, "Expression: ${android.customPackage}", 3 );
                append( sb, "", 0 );

                append( sb, "device", 2 );
                append( sb, "Specifies which device to connect to, by serial number. Special values \'usb\' and \'emulator\' are also valid, for selecting the only USB connected device or the only running emulator, respectively.", 3 );
                append( sb, "Expression: ${android.device}", 3 );
                append( sb, "", 0 );

                append( sb, "generateApk (Default: true)", 2 );
                append( sb, "Decides whether the Apk should be generated or not. If set to false, dx and apkBuilder will not run. This is probably most useful for a project used to generate apk sources to be inherited into another application project.", 3 );
                append( sb, "Expression: ${android.generateApk}", 3 );
                append( sb, "", 0 );

                append( sb, "nativeLibrariesDirectory (Default: ${project.basedir}/libs)", 2 );
                append( sb, "Root folder containing native libraries to include in the application package.\n", 3 );
                append( sb, "Expression: ${android.nativeLibrariesDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDirectory (Default: ${project.basedir}/res)", 2 );
                append( sb, "The android resources directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectories", 2 );
                append( sb, "The android resources overlay directories. If this is specified, the resourceOverlayDirectory parameter will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "resourceOverlayDirectory (Default: ${project.basedir}/res-overlay)", 2 );
                append( sb, "The android resources overlay directory. This will be overriden by resourceOverlayDirectories if present.", 3 );
                append( sb, "", 0 );

                append( sb, "sdk", 2 );
                append( sb, "The Android SDK to use.\n\nLooks like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>/opt/android-sdk-linux</path>\n\u00a0\u00a0\u00a0\u00a0<platform>2.1</platform>\n</sdk>\n\nThe <platform> parameter is optional, and corresponds to the platforms/android-* directories in the Android SDK directory. Default is the latest available version, so you only need to set it if you for example want to use platform 1.5 but also have e.g. 2.2 installed. Has no effect when used on an Android SDK 1.1. The parameter can also be coded as the API level. Therefore valid values are 1.1, 1.5, 1.6, 2.0, 2.01, 2.1, 2,2 as well as 3, 4, 5, 6, 7, 8. If a platform/api level is not installed on the machine an error message will be produced.\n\nThe <path> parameter is optional. The default is the setting of the ANDROID_HOME environment variable. The parameter can be used to override this setting with a different environment variable like this:\n\n<sdk>\n\u00a0\u00a0\u00a0\u00a0<path>${env.ANDROID_SDK}</path>\n</sdk>\n\nor just with a hardcoded absolute path. The parameters can also be configured from command-line with parameters -Dandroid.sdk.path and -Dandroid.sdk.platform.\n", 3 );
                append( sb, "", 0 );

                append( sb, "undeployBeforeDeploy (Default: false)", 2 );
                append( sb, "Whether to undeploy an apk from the device before deploying it.\n\nOnly has effect when running mvn android:deploy in an Android application project manually, or when running mvn integration-test (or mvn install) in a project with instrumentation tests.\n\nIt is useful to keep this set to true at all times, because if an apk with the same package was previously signed with a different keystore, and deployed to the device, deployment will fail becuase your keystore is different.\n", 3 );
                append( sb, "Expression: ${android.undeployBeforeDeploy}", 3 );
                append( sb, "", 0 );

                append( sb, "zipalign", 2 );
                append( sb, "The configuration for the zipalign goal. As soon as a zipalign goal is invoked the command will be executed unless the skip parameter is set. By default the input file is the apk produced by the build in target. The outputApk will use the postfix -aligned.apk. The following shows a default full configuration of the zipalign goal as an example for changes as plugin configuration.\n<zipalign>\n\u00a0\u00a0\u00a0\u00a0<skip>false</skip>\n\u00a0\u00a0\u00a0\u00a0<verbose>true</verbose>\n\u00a0\u00a0\u00a0\u00a0<inputApk>${project.build.directory}/${project.artifactId}.apk</inputApk>\n\u00a0\u00a0\u00a0\u00a0<outputApk>${project.build.directory}/${project.artifactId}-aligned.apk</outputApk>\n</zipalign>\nValues can also be configured as properties on the command line as android.zipalign.* or in pom or settings file as properties like zipalign.*.", 3 );
                append( sb, "", 0 );

                append( sb, "zipalignInputApk", 2 );
                append( sb, "The apk file to be zipaligned. Per default the file is taken from build directory (target normally) using the build final name as file name and apk as extension.", 3 );
                append( sb, "Expression: ${android.zipalign.inputApk}", 3 );
                append( sb, "", 0 );

                append( sb, "zipalignOutputApk", 2 );
                append( sb, "The apk file produced by the zipalign goal. Per default the file is placed into the build directory (target normally) using the build final name appended with \'-aligned\' as file name and apk as extension.", 3 );
                append( sb, "Expression: ${android.zipalign.outputApk}", 3 );
                append( sb, "", 0 );

                append( sb, "zipalignSkip", 2 );
                append( sb, "Skip the zipalign goal execution.", 3 );
                append( sb, "Expression: ${android.zipalign.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "zipalignVerbose", 2 );
                append( sb, "Activate verbose output for the zipalign goal execution.", 3 );
                append( sb, "Expression: ${android.zipalign.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
